Skip to main content
POST
/
guardrails
Create a guardrail
curl --request POST \
  --url https://openrouter.ai/api/v1/guardrails \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "allowed_models": null,
  "allowed_providers": [
    "openai",
    "anthropic",
    "deepseek"
  ],
  "description": "A guardrail for limiting API usage",
  "enforce_zdr_anthropic": true,
  "enforce_zdr_google": false,
  "enforce_zdr_openai": true,
  "enforce_zdr_other": false,
  "ignored_models": null,
  "ignored_providers": null,
  "limit_usd": 50,
  "name": "My New Guardrail",
  "reset_interval": "monthly"
}
'
{
  "data": {
    "allowed_models": null,
    "allowed_providers": [
      "openai",
      "anthropic",
      "google"
    ],
    "created_at": "2025-08-24T10:30:00Z",
    "description": "A guardrail for limiting API usage",
    "enforce_zdr": null,
    "enforce_zdr_anthropic": true,
    "enforce_zdr_google": false,
    "enforce_zdr_openai": true,
    "enforce_zdr_other": false,
    "id": "550e8400-e29b-41d4-a716-446655440000",
    "ignored_models": null,
    "ignored_providers": null,
    "limit_usd": 50,
    "name": "My New Guardrail",
    "reset_interval": "monthly",
    "updated_at": null,
    "workspace_id": "0df9e665-d932-5740-b2c7-b52af166bc11"
  }
}

Authorizations

Authorization
string
header
required

API key as bearer token in Authorization header

Body

application/json
name
string
required

Name for the new guardrail

Required string length: 1 - 200
Example:

"My New Guardrail"

allowed_models
string[] | null

Array of model identifiers (slug or canonical_slug accepted)

Minimum array length: 1
Example:
[
"openai/gpt-5.2",
"anthropic/claude-4.5-opus-20251124",
"deepseek/deepseek-r1-0528:free"
]
allowed_providers
string[] | null

List of allowed provider IDs

Minimum array length: 1
Example:
["openai", "anthropic", "deepseek"]
content_filter_builtins
object[] | null

Builtin content filters to apply. The "flag" action is only supported for "regex-prompt-injection"; PII slugs (email, phone, ssn, credit-card, ip-address, person-name, address) accept "block" or "redact" only.

Example:
[
{
"action": "block",
"slug": "regex-prompt-injection"
}
]
content_filters
object[] | null

Custom regex content filters to apply to request messages

Example:
[
{
"action": "redact",
"label": "[API_KEY]",
"pattern": "\\b(sk-[a-zA-Z0-9]{48})\\b"
}
]
description
string | null

Description of the guardrail

Maximum string length: 1000
Example:

"A guardrail for limiting API usage"

enforce_zdr
boolean | null
deprecated

Deprecated. Use enforce_zdr_anthropic, enforce_zdr_openai, enforce_zdr_google, and enforce_zdr_other instead. When provided, its value is copied into any of those per-provider fields that are not explicitly specified on the request.

Example:

false

enforce_zdr_anthropic
boolean | null

Whether to enforce zero data retention for Anthropic models. Falls back to enforce_zdr when not provided.

Example:

false

enforce_zdr_google
boolean | null

Whether to enforce zero data retention for Google models. Falls back to enforce_zdr when not provided.

Example:

false

enforce_zdr_openai
boolean | null

Whether to enforce zero data retention for OpenAI models. Falls back to enforce_zdr when not provided.

Example:

false

enforce_zdr_other
boolean | null

Whether to enforce zero data retention for models that are not from Anthropic, OpenAI, or Google. Falls back to enforce_zdr when not provided.

Example:

false

ignored_models
string[] | null

Array of model identifiers to exclude from routing (slug or canonical_slug accepted)

Minimum array length: 1
Example:
["openai/gpt-4o-mini"]
ignored_providers
string[] | null

List of provider IDs to exclude from routing

Minimum array length: 1
Example:
["azure"]
limit_usd
number<double> | null

Spending limit in USD

Example:

50

reset_interval
enum<string> | null

Interval at which the limit resets (daily, weekly, monthly)

Available options:
daily,
weekly,
monthly,
null
Example:

"monthly"

workspace_id
string<uuid>

The workspace to create the guardrail in. Defaults to the default workspace if not provided.

Example:

"0df9e665-d932-5740-b2c7-b52af166bc11"

Response

Guardrail created successfully

data
object
required

The created guardrail

Example:
{
"allowed_models": null,
"allowed_providers": ["openai", "anthropic", "google"],
"content_filter_builtins": [
{
"action": "redact",
"label": "[EMAIL]",
"slug": "email"
}
],
"content_filters": null,
"created_at": "2025-08-24T10:30:00Z",
"description": "Guardrail for production environment",
"enforce_zdr": null,
"enforce_zdr_anthropic": true,
"enforce_zdr_google": false,
"enforce_zdr_openai": true,
"enforce_zdr_other": false,
"id": "550e8400-e29b-41d4-a716-446655440000",
"ignored_models": null,
"ignored_providers": null,
"limit_usd": 100,
"name": "Production Guardrail",
"reset_interval": "monthly",
"updated_at": "2025-08-24T15:45:00Z",
"workspace_id": "0df9e665-d932-5740-b2c7-b52af166bc11"
}